<?php

namespace Teknisa\EST\Factories;

class Ger03700AlmoxarifadoLocalizacao {
    protected $connection;

    public function __construct($entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function updateLocalEstoque($iddispconped, $cdalmoxarife, $cdfilial, $nrorg) {
        $sql = "UPDATE LOCALESTOQUE
                  SET IDDISPCONPED = NVL(:IDDISPCONPED,'N')
                WHERE CDALMOXARIFE = :CDALMOXARIFE
                  AND CDFILIAL     = :CDFILIAL
                  AND NRORG = :NRORG";

        $params = array('IDDISPCONPED'=>$iddispconped,
                        'CDALMOXARIFE'=>$cdalmoxarife,
                        'CDFILIAL'=>$cdfilial,
                        'NRORG'=>$nrorg);

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function selectAllLocalizacoes($cdalmoxarife, $cdfilial, $nrorg) {
        $sql = "SELECT NRORG, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ
                FROM LOCALESTOQUE
                WHERE NRORG       = :NRORG
                  AND CDFILIAL      = :CDFILIAL
                  AND CDALMOXARIFE  = :CDALMOXARIFE";

        $params = array('NRORG'=>$nrorg,
                        'CDFILIAL'=>$cdfilial,
                        'CDALMOXARIFE'=>$cdalmoxarife);

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function deleteAllLocalizacoes($cdalmoxarife, $cdfilial, $nrorg, $cdlocalestoq) {
        $sql = "DELETE FROM LOCALESTOQUE
                WHERE NRORG       = :NRORG
                  AND CDFILIAL      = :CDFILIAL
                  AND CDALMOXARIFE  = :CDALMOXARIFE
                  AND CDLOCALESTOQ  = :CDLOCALESTOQ";

        $params = array('NRORG'=>$nrorg,
                        'CDFILIAL'=>$cdfilial,
                        'CDALMOXARIFE'=>$cdalmoxarife,
                        'CDLOCALESTOQ'=>$cdlocalestoq);

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function deleteAlmoxarifado($cdalmoxarife, $cdfilial, $nrorg) {
        $sql = "DELETE FROM ALMOXARIFADO
                WHERE NRORG       = :NRORG
                  AND CDFILIAL      = :CDFILIAL
                  AND CDALMOXARIFE  = :CDALMOXARIFE";

        $params = array('NRORG'=>$nrorg,
                        'CDFILIAL'=>$cdfilial,
                        'CDALMOXARIFE'=>$cdalmoxarife);

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function selectAlmoxarifadoLocalizacaoPadrao($cdfilial, $nrorg){
        $sql = "SELECT CDALMOXARIFE, CDLOCALESTOQ
                FROM PARAMFILIAL
                WHERE CDFILIAL = :CDFILIAL
                  AND NRORG = :NRORG";

        $params = array('CDFILIAL'=>$cdfilial,
                        'NRORG'=>$nrorg);

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}