package com.javaseleniumtemplate.tests.Estoque;
import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.AjusteInventarioFlows;
import com.javaseleniumtemplate.flows.ImplantacaoEstoqueFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.EstoquePages.Estoque.AjusteInventarioPage;
import com.javaseleniumtemplate.pages.EstoquePages.Estoque.ImplantacaoEstoquePage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.annotations.Test;

public class ImplantacaoDeEstoqueTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    ImplantacaoEstoqueFlows implantacaoEstoqueFlows;
    ImplantacaoEstoquePage implantacaoEstoquePage;


    @Test
    public void efetuarImplantacaoEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        implantacaoEstoqueFlows = new ImplantacaoEstoqueFlows();
        implantacaoEstoquePage = new ImplantacaoEstoquePage();

        //Parameteres
        String usuario = "sandro.silva@teknisa.com";
        String senha = "Teknisa@2022";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descAlmoxarifado = "HELA MATRIZ";
        String quantidade = "1";
        String cmpDesc = "Testes Automatizados";
        String descProduto = "Hela Poultry Broth Paste Clear KG";
        String DescCampoLote = "Testes Automatizados";
            //Parameteres_Editar
        String quantidadeEdit = "1,75";
        String descProduto2 = "Geflugelbruhe Paste (Hela 7562510050001)";
        String cmpDesc2 = "Deletar";
        //String nomeProduto = "Hela Poultry Broth Paste Clear KG";
        //String quantidadeProduto = "1";
        //String statusEsperado = "Pendente";

        loginFlows.efetuarLogin(usuario,senha);
        mainFlows.AcessandoImplantacaoEstoque();
        implantacaoEstoqueFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        implantacaoEstoqueFlows.AdicionarImplantacaoEstoque(quantidade,cmpDesc,descProduto,descAlmoxarifado,DescCampoLote);
        //implantacaoEstoqueFlows.EditarImplantacaoEstoque(cmpDesc2,quantidadeEdit,descProduto2,descAlmoxarifado,DescCampoLote);
        //implantacaoEstoqueFlows.ExcluirImplantacaoEstoque();

    }
    @Test
    public void editarImplantacaoEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        implantacaoEstoqueFlows = new ImplantacaoEstoqueFlows();
        implantacaoEstoquePage = new ImplantacaoEstoquePage();

        //Parameteres
        String usuario = "sandro.silva@teknisa.com";
        String senha = "Teknisa@2022";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descAlmoxarifado = "HELA MATRIZ";
        String DescCampoLote = "Testes Automatizados";
        //Parameteres_Editar
        String quantidadeEdit = "1,75";
        String descProduto2 = "Geflugelbruhe Paste (Hela 7562510050001)";
        String cmpDesc2 = "Deletar";

        loginFlows.efetuarLogin(usuario,senha);
        mainFlows.AcessandoImplantacaoEstoque();
        implantacaoEstoqueFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        implantacaoEstoqueFlows.EditarImplantacaoEstoque(cmpDesc2,quantidadeEdit,descProduto2,descAlmoxarifado,DescCampoLote);

    }
    @Test
    public void excluirImplantacaoEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        implantacaoEstoqueFlows = new ImplantacaoEstoqueFlows();
        implantacaoEstoquePage = new ImplantacaoEstoquePage();

        //Parameteres
        String usuario = "sandro.silva@teknisa.com";
        String senha = "Teknisa@2022";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descAlmoxarifado = "HELA MATRIZ";

        loginFlows.efetuarLogin(usuario,senha);
        mainFlows.AcessandoImplantacaoEstoque();
        implantacaoEstoqueFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        implantacaoEstoqueFlows.ExcluirImplantacaoEstoque();

    }
    @Test
    public void importarImplantacaoDeEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        implantacaoEstoqueFlows = new ImplantacaoEstoqueFlows();
        implantacaoEstoquePage = new ImplantacaoEstoquePage();

        //Parameteres
        String usuario = "sandro.silva@teknisa.com";
        String senha = "Teknisa@2022";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descAlmoxarifado = "HELA MATRIZ";


        loginFlows.efetuarLogin(usuario,senha);
        mainFlows.AcessandoImplantacaoEstoque();
        implantacaoEstoqueFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        implantacaoEstoqueFlows.ImportarImplantacaoDeEstoque();

    }


}
